VERSION 5.00
Begin VB.Form frmConnection 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Login"
   ClientHeight    =   3150
   ClientLeft      =   45
   ClientTop       =   390
   ClientWidth     =   4680
   Icon            =   "frmConnection.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   Moveable        =   0   'False
   ScaleHeight     =   3150
   ScaleLeft       =   100
   ScaleMode       =   0  'User
   ScaleWidth      =   4680
   StartUpPosition =   2  'CenterScreen
   Begin VB.OptionButton OptNT 
      Caption         =   "NT"
      Height          =   255
      Left            =   3450
      TabIndex        =   6
      Top             =   1395
      Width           =   615
   End
   Begin VB.OptionButton OptLDAP 
      Caption         =   "LDAP"
      Height          =   255
      Left            =   2520
      TabIndex        =   5
      Top             =   1395
      Width           =   855
   End
   Begin VB.OptionButton OptStandard 
      Caption         =   "Standard"
      Height          =   255
      Left            =   1320
      TabIndex        =   4
      Top             =   1395
      Value           =   -1  'True
      Width           =   1095
   End
   Begin VB.CheckBox chkGod 
      Caption         =   "God Mode"
      Height          =   255
      Left            =   2100
      TabIndex        =   13
      Top             =   2835
      Width           =   1095
   End
   Begin VB.CommandButton btnSelectProject 
      Caption         =   "Select Project"
      Enabled         =   0   'False
      Height          =   285
      Left            =   1515
      TabIndex        =   12
      Top             =   2535
      Width           =   2265
   End
   Begin VB.ComboBox cbProjects 
      Enabled         =   0   'False
      Height          =   315
      Left            =   990
      Sorted          =   -1  'True
      TabIndex        =   7
      Top             =   2130
      Width           =   3615
   End
   Begin VB.ComboBox cbProjectList 
      Height          =   315
      Left            =   990
      Sorted          =   -1  'True
      TabIndex        =   1
      Top             =   135
      Width           =   3615
   End
   Begin VB.CommandButton btnConnect 
      Caption         =   "Connect"
      Default         =   -1  'True
      Height          =   285
      Left            =   1485
      TabIndex        =   11
      Top             =   1680
      Width           =   2310
   End
   Begin VB.TextBox txtPWD 
      Height          =   330
      IMEMode         =   3  'DISABLE
      Left            =   990
      PasswordChar    =   "*"
      TabIndex        =   3
      Top             =   990
      Width           =   3570
   End
   Begin VB.TextBox txtUID 
      Height          =   330
      Left            =   990
      TabIndex        =   2
      Top             =   540
      Width           =   3570
   End
   Begin VB.Label Label3 
      Caption         =   "Password:"
      Height          =   240
      Left            =   90
      TabIndex        =   10
      Top             =   1035
      Width           =   810
   End
   Begin VB.Label Label2 
      Caption         =   "Login id:"
      Height          =   240
      Left            =   90
      TabIndex        =   9
      Top             =   630
      Width           =   690
   End
   Begin VB.Label Label1 
      Caption         =   "Projects:"
      Height          =   240
      Left            =   90
      TabIndex        =   8
      Top             =   2175
      Width           =   735
   End
   Begin VB.Label S 
      Caption         =   "Server:"
      Height          =   195
      Left            =   90
      TabIndex        =   0
      Top             =   180
      Width           =   735
   End
End
Attribute VB_Name = "frmConnection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private mCancel As Boolean
Private reg As String


Private Sub cbProjectList_Change()

reg = ""
reg = basRegistry.regQuery_A_Key(HKEY_LOCAL_MACHINE, "SOFTWARE\MicroStrategy\Data Sources\" & cbProjectList.Text, "MetadataLogin")
If reg = "" Then
    reg = basRegistry.regQuery_A_Key(HKEY_CURRENT_USER, "SOFTWARE\MicroStrategy\DSS Agent\DSS Logon\", cbProjectList.Text & "\LOGIN")
End If

Me.txtUID.Text = reg

End Sub
Private Sub cbProjectList_click()

reg = ""
reg = basRegistry.regQuery_A_Key(HKEY_LOCAL_MACHINE, "SOFTWARE\MicroStrategy\Data Sources\" & cbProjectList.Text, "MetadataLogin")
If reg = "" Then
    reg = basRegistry.regQuery_A_Key(HKEY_CURRENT_USER, "SOFTWARE\MicroStrategy\DSS Agent\DSS Logon\", cbProjectList.Text & "\LOGIN")
End If

Me.txtUID.Text = reg

End Sub

Private Sub form_load()

    
    'Indicate a busy mouse icon...
    MousePointer = vbHourglass
    
    FrmExplorer_new.Enabled = False
    
    'getting the available datasources
    Set objProjectList = New DSSDataSourceEnumerator
    
    'load registry content
    objProjectList.LoadFromRegistry

    'add the project sources into the combo list
    If objProjectList.count > 0 Then
        For i = 1 To objProjectList.count
            'exclude the registry entry that looks like {...}
            'find more by going to regedit -> HKEY_LOCAL_MACHINE -> SOFTWARE -> MICROSTRATEGY -> DATA SOURCES
            If Not (objProjectList.Item(i).name Like "{*}" Or objProjectList.Item(i).name Like "Castor*") Then
                cbProjectList.AddItem (objProjectList.Item(i).name)
            End If
        Next i
    End If
    
    'indicate a default mouse icon...
    MousePointer = vbDefault
    
    'highlight and select the first item in the combo list
    cbProjectList.Text = cbProjectList.list(0)
    
End Sub


Private Sub btnConnect_Click()
    
    
    On Error GoTo errHandler
    
    'Test if at least User was provided
    If Me.txtUID.Text = "" Then
        MsgBox "Please enter user name", vbCritical, "Error Connecting"
        Exit Sub
    End If
    
    'indicate a busy mouse icon...
    MousePointer = vbHourglass
    
    'get the project source name based on the combo list selection
    'using the string name is not enough, thus the objProjectList must be called
    For i = 1 To objProjectList.count
        If Me.cbProjectList.Text = objProjectList.Item(i).name Then
            DataSournceInd = i 'this is the index of the selected project
        End If
    Next i
    
    'provide connection information
    Set objServer = objProjectList.Item(DataSournceInd)
    If Me.OptStandard = True Then objServer.AuthMode = DssAuthStandard
    If Me.OptLDAP = True Then objServer.AuthMode = DssAuthLDAP
    If Me.OptNT = True Then objServer.AuthMode = DssAuthNTCredential
    objServer.login = Me.txtUID.Text
    objServer.Passwd = Me.txtPWD.Text

    'connect to Project Source
    objServer.Init
    
    
    'getting all projects
    If objServer.Enumerator.count > 0 Then
        For i = 1 To objServer.Enumerator.count
            cbProjects.AddItem objServer.Enumerator.Item(i).ProjectName
        Next i
    Else
        MsgBox strErr, vbCritical, "No projects found!"
    End If
    
    'highlight and select the first project in the combo list
    cbProjects.Text = cbProjects.list(0)
    
    'cosmetical stuff
    cbProjects.Enabled = True
    cbProjects.SetFocus
    btnSelectProject.Default = True
    btnSelectProject.Enabled = True

    'Indicate a default mouse icon...
    MousePointer = vbDefault
    
    
'display error information
errHandler: If Err.Description <> "" Then
                MsgBox Err.Description, , "Login error"
                'indicate a default mouse icon...
                MousePointer = vbDefault
            End If
    
 
End Sub

Public Function ShowDlg(Optional ParentForm As Form) As Boolean
    Me.btnSelectProject.Enabled = False
    mCancel = False
    Me.Show vbModal, ParentForm
    If Not mCancel Then
        ShowDlg = True
    End If
    Unload Me
End Function

Private Sub btnSelectProject_Click()
    
    On Error GoTo errHandler
    
    
    'get the project name based on the combo list selection
    For i = 1 To objServer.Enumerator.count
        If Me.cbProjects.Text = objServer.Enumerator.Item(i).ProjectName Then
            ServerInd = i
        End If
    Next i
    
    'provide connection information
    Set objDataSource = objServer.Enumerator.Item(ServerInd)
    If Me.OptStandard = True Then objDataSource.AuthMode = DssAuthStandard
    If Me.OptLDAP = True Then objDataSource.AuthMode = DssAuthLDAP
    If Me.OptNT = True Then objDataSource.AuthMode = DssAuthNTCredential
    objDataSource.login = Me.txtUID.Text
    objDataSource.Passwd = Me.txtPWD.Text
    
    'connect to project
    objDataSource.Init
    Set objSession = objDataSource.CreateSession
    
    
    'indicate a default mouse icon...
    MousePointer = vbDefault
    

'display error information
errHandler: If Err.Description <> "" Then
                MsgBox Err.Description, , "Login error"
                'indicate a default mouse icon...
                MousePointer = vbDefault
            End If

    If Err.Description = "" Then
        

        'Update the status bar text
        FrmExplorer_new.StatusBar.SimpleText = "Connected to " & objProjectList.Item(DataSournceInd).name & " on " & objServer.Enumerator.Item(ServerInd).ProjectName
        
        If Me.chkGod.Value = 1 Then
            GodMode = True
            FrmExplorer_new.Caption = "Metadata Browser v3.01 >>> GOD MODE <<<"
        End If
        
        connected = True
        
        
        'Call frmExplorer_new
        FrmExplorer_new.Enabled = True
        FrmExplorer_new.Toolbar1.Buttons(3).Enabled = True
        FrmExplorer_new.Toolbar4.Buttons(1).Enabled = True
        Call FrmExplorer_new.SetNodes
        
        'Unload this form
        Unload frmConnection
    End If
    
End Sub





Private Sub txtPWD_KeyPress(KeyAscii As Integer)
    If KeyAscii = 13 Then
        Call btnConnect_Click
    End If
End Sub



Private Sub Form_Unload(Cancel As Integer)

    FrmExplorer_new.Enabled = True
    FrmExplorer_new.Show

End Sub
